package com.muyu.event.controller;

import com.muyu.demos.model.Result;
import com.muyu.event.common.CarEvent;
import com.muyu.event.service.EventService;
import com.muyu.mqtt.dao.MessageData;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 事件处理器控制层 EventController
 *
 * @author Yangle
 * Date 2024/6/17 19:53
 */
@RestController("/event")
public class EventController {


    @Autowired
    private EventService eventService;

    @PostMapping("/bindingEvent")
    public Result<List<CarEvent>> bindingEvent(@RequestBody CarEvent carEvent) {
        return Result.success(eventService.getCarEventList(carEvent));
    }

    @PostMapping("/selectEvent")
    public Result<MessageData> selectEvent(@RequestBody CarEvent carEvent) {
        Result<MessageData> messageDataResult = eventService.selectEvent(carEvent);
        return messageDataResult;
    }
}
