package com.muyu.event.service.impl;

import com.alibaba.fastjson.JSON;
import com.muyu.demos.model.Result;
import com.muyu.event.common.CarEvent;
import com.muyu.event.mapper.EventMapper;
import com.muyu.event.service.EventService;
import com.muyu.mqtt.dao.MessageData;
import lombok.extern.log4j.Log4j2;
import org.apache.kafka.clients.admin.NewTopic;
import org.apache.kafka.clients.producer.ProducerRecord;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Set;

/**
 * EventServiceImpl
 *
 * @author Yangle
 * Date 2024/6/17 19:57
 */
@Service
@Log4j2
public class EventServiceImpl implements EventService {
    @Autowired
    private EventMapper eventMapper;

    @Autowired
    private RedisTemplate<String,String> redisTemplate;
    @Override
    public List<CarEvent> getCarEventList(CarEvent carEvent) {
        return eventMapper.getCarEventList(carEvent);
    }

    @Override
    public Result<MessageData> selectEvent(CarEvent carEvent) {
        if (carEvent.getEvent() != null) {

            if (carEvent.getEvent().contains("1")) {
                System.out.println("1");
            }
            if (carEvent.getEvent().contains("2")) {
                String maximumCoordinate = getMaximumCoordinate(carEvent.getVin());
                MessageData messageData = JSON.parseObject(maximumCoordinate, MessageData.class);
                return Result.success(messageData);
            }
            if (carEvent.getEvent().contains("3")) {

            }
        }
            return Result.error("车辆没有绑定事件");
    }

    /**
     * 获取最大的坐标的数据
     * @return
     */
    public String getMaximumCoordinate (String vin) {
        String index = redisTemplate.opsForList().index(vin, -1);
        return index;
    }
//    //创建分区
//    NewTopic newTopic = new NewTopic(topic, 8, (short) 1);
//        kafkaAdmin.createOrModifyTopics(newTopic);
//    ProducerRecord<String, String> producerRecord = new ProducerRecord<>(topic, main.getVin(), JSON.toJSONString(main));
//    // 发送消息
//        kafkaTemplate.send(producerRecord);
}
